#include <windows.h>
#include "CGame.h"

HWND gHWND;
HINSTANCE gHINSTANCE;

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
		break;

	case WM_QUIT:
		return 0;
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hOrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	gHINSTANCE = hInstance;

	WNDCLASS wc;
	ZeroMemory(&wc, sizeof(WNDCLASS));

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.hInstance = gHINSTANCE;
	wc.hIcon = ::LoadIcon(0, IDI_APPLICATION);
	wc.hCursor = ::LoadCursor(0, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)::GetStockObject(NULL_BRUSH);
	wc.lpszClassName = L"Windows3DClass";

	RegisterClass(&wc);

	int width = 800;
	int height = 600;

	RECT rcClientArea;
	rcClientArea.left = 0;
	rcClientArea.right = width;
	rcClientArea.top = 0;
	rcClientArea.bottom = height;

	AdjustWindowRect(&rcClientArea, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU, false);

	gHWND = CreateWindow(wc.lpszClassName, L"xdpixel - DX12 Simple Bundle Sample", WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU,
		0, 0, rcClientArea.right - rcClientArea.left, rcClientArea.bottom - rcClientArea.top
		, NULL, NULL, gHINSTANCE, NULL);

	if (gHWND == NULL)
	{
		::MessageBoxA(NULL, "Error creating window.", "Windows Error", MB_OK | MB_ICONERROR);
		return false;
	}

	ShowWindow(gHWND, nShowCmd);
	UpdateWindow(gHWND);

	CGame game;
	game.Initialize(reinterpret_cast<void*>(gHWND), width, height);

	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));
	GetMessage(&msg, 0, 0, 0);
	while (msg.message != WM_QUIT)
	{
		if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE) != 0)
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			game.Update();
			game.Render();

			if (GetKeyState(VK_ESCAPE) & 0x8000)
			{
				PostQuitMessage(0);
			}
		}
	}

    game.Shutdown();

	return (int)msg.wParam;
}